
//
// Copyright 2002, Lowell Boggs Jr.
//
// This file or directory, containing source code for a computer program,
// is Copyrighted by Lowell Boggs, Jr.  987 Regency Drive, Lewisville
// TX (USA), 75067.  You may use, copy, modify, and distribute this
// source file without charge or obligation so long as you agree to
// the following:
//
//  1.  You must indemnify Lowell Boggs against any and all financial
//      obligations caused by its use, misuse, function, or malfunction.
//      Further, you acknowledge that there is no warranty of any kind,
//      whatsoever.
//
//  2.  You agree not to attempt to patent any portion of this original
//      work -- though you may attempt to patent your own extensions to
//      it if you so choose.
//
//  3.  You keep this copyright notice with the file and all copies
//      of the file and do not change it anyway except language translation.
//
// You are responsible for enforcing your own compliance with these
// conditions and may not use this source file if you cannot agree to the
// above terms and conditions.

///@file
/// Implements CPP_Token class.


#include <cxxtls/cpp_token_stream.h>
#include <portable_io.h>

namespace cxxtls
{

std::string
CPP_Token::
type_name(int id)
{
  switch(id)
  {
    case eof : return "<eof>";
    case eql : return "==";
    case neq : return "!=";
    case leq : return "<=";
    case geq : return ">=";
    case sle : return "<<=";
    case sre : return ">>=";
    case dve : return "/=";
    case ple : return "+=";
    case mne : return "-=";
    case tme : return "*=";
    case mde : return "%=";
    case adr : return "& ";
    case orr : return "||";
    case ore : return "|=";
    case ade : return "&=";
    case inc : return "++";
    case dec : return "--";
    case shr : return ">>";
    case shl : return "<<";
    case lan : return "&&";
    case der : return "::";
    case teq : return "~=";
    case ceq : return "^=";
    case eli : return "...";
    case nmb : return "number";
    case aln : return "identifier";
    case inv : return "invalid operator";

    default:

      if(id > 0x100)
      {
	char buf[40];
	
	sprintf(buf, "<%03x>", id);
	
	return buf;
      }
  }

  char buffer[2];

  buffer[0] = id;
  buffer[1] = 0;

  return buffer;

}
} // namespace cxxtls
